---
title: IDBOpenDBRequest.onupgradeneeded
slug: Web/API/IDBOpenDBRequest/onupgradeneeded
tags:
  - API
  - Database
  - IDBOpenDBRequest
  - IndexedDB
  - Property
  - Reference
  - Storage
  - onupgradeneeded
---
<p>{{ APIRef("IndexedDB") }}</p>

<div>
<p>The <strong><code>onupgradeneeded</code></strong> property of the {{domxref("IDBOpenDBRequest")}} interface is the event handler for the {{event("upgradeneeded")}} event, triggered when a database of a bigger version number than the existing stored database is loaded.</p>

<p>The event passed to the handler is an {{domxref("IDBVersionChangeEvent")}}.</p>

<p>Inside the event handler function you can include code to upgrade the database structure, as shown in the example below.</p>

<p>{{AvailableInWorkers}}</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>IDBOpenDBRequest</em>.onupgradeneeded = <em>function</em>(event) { ... };</pre>

<h2 id="Example">Example</h2>

<p>In the following example you can see the onupgradeneeded handler being used to update the database structure if a database with a higher version number is loaded. For a full working example, see our <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> app (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</p>

<pre class="brush: js; highlight:[17,29,30,32,33,34,35,36,37] notranslate">var db;

// Request version 3 of the database.
var request = window.indexedDB.open("library", 3);

// This event handles the event whereby a new version of the
// database needs to be created. Either one has not been created
// before, or a new version number has been submitted via the
// window.indexedDB.open line above.
request.onupgradeneeded = function(event) {
  db = request.result;

  db.onerror = function(errorEvent) {
    note.innerHTML += '&lt;li&gt;Error loading database.&lt;/li&gt;';
  };

  if (event.oldVersion &lt; 1) {
    // Version 1 is the first version of the database.
    var store = db.createObjectStore("books", {keyPath: "isbn"});
    var titleIndex = store.createIndex("by_title", "title", {unique: true});
    var authorIndex = store.createIndex("by_author", "author");
  }
  if (event.oldVersion &lt; 2) {
    // Version 2 introduces a new index of books by year.
    var bookStore = request.transaction.objectStore("books");
    var yearIndex = bookStore.createIndex("by_year", "year");
  }
  if (event.oldVersion &lt; 3) {
    // Version 3 introduces a new object store for magazines with two indexes.
    var magazines = db.createObjectStore("magazines");
    var publisherIndex = magazines.createIndex("by_publisher", "publisher");
    var frequencyIndex = magazines.createIndex("by_frequency", "frequency");
  }
};

request.onerror = function(event) {
  note.innerHTML += '&lt;li&gt;Error loading database.&lt;/li&gt;';
};

request.onsuccess = function(event) {
  note.innerHTML += '&lt;li&gt;Database initialised.&lt;/li&gt;';
  db = request.result;
  populateAndDisplayData();
};

</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB', '#dom-idbopendbrequest-onupgradeneeded', 'onupgradeneeded')}}</td>
   <td>{{Spec2('IndexedDB')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#dom-idbopendbrequest-onupgradeneeded", "onupgradeneeded")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>
<div>

<p>{{Compat("api.IDBOpenDBRequest.onupgradeneeded")}}</p>
</div>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
 <li><code><a href="/en-US/docs/Web/API/IDBRequest/upgradeneeded_event">upgradeneeded</a></code> event</li>
</ul>
